<template>
  <!-- component for all merge requests -->

  <div class="mrTable">
    <!-- option for types of merge lists -->

    <section class="navigation">
      <!-- <label for="request" disabled> Select Merge Request Type - </label> -->
      <el-select
        class="mrTableBtn"
        v-model="mergeListState"
        @change="switchMergeList(mergeListState)"
        name="request"
        id="request"
      >
        <el-option label="Merged" value="merged" />
        <el-option label="Opened" value="opened" />
      </el-select>
    </section>
    <br />

    <el-row type="flex" justify="center">
      <el-col :span="10">
        <el-table
          :data="showApprovers.data"
          v-if="showApprovers.show"
          border
          resizable
        >
          <el-table-column
            prop="approvers"
            label="Mandatory Approver"
            min-width="200"
          >
            <template slot-scope="scope">
              <p v-for="person in scope.row.approvers" :key="person.id">
                {{ person }}
              </p>
            </template>
          </el-table-column>
          <el-table-column
            prop="no_of_approvers"
            label="No of Approvers Required"
            min-width="200"
          >
          </el-table-column>
        </el-table>
      </el-col>
    </el-row>
    <br />

    <!-- loader for loading -->

    <div v-if="loading"><h4>Loading ..</h4></div>
    <br />

    <!-- table starting  -->
    <el-row type="flex" justify="center" v-if="!loading">
      <el-col :span="20">
        <el-table :data="tableData" border resizable>
          <el-table-column
            prop="web_url"
            label="Merge Request URL"
            min-width="300"
          >
            <template slot-scope="scope">
              <a
                style="cursor: pointer"
                target="_blank"
                :href="scope.row.web_url"
                >{{ scope.row.web_url }}</a
              >
            </template>
          </el-table-column>
          <el-table-column
            prop="approvalsData"
            label="Approved By"
            min-width="200"
          >
            <template slot-scope="scope">
              <p v-for="item in scope.row.approved_by" :key="item.id">
                {{ item }}
              </p>
            </template>
          </el-table-column>
          <el-table-column
            prop="state"
            label="Status"
            align="center"
            min-width="100"
          />
          <el-table-column
            label="Merge"
            align="center"
            v-if="mergeListState === 'opened'"
            min-width="150"
          >
            <template slot-scope="scope">
              <el-button
                v-if="!scope.row.has_conflicts && checkMerge(scope.row.approved_by)"
                type="danger"
                @click="mergeOpenRequest(scope.row.iid)"
              >
                Merge
              </el-button>
              <el-button v-else type="danger" disabled> Merge </el-button>
            </template>
          </el-table-column>
          <el-table-column prop="has_conflicts" label="Comment" min-width="200">
            <template slot-scope="scope">
              <p v-if="!checkMerge(scope.row.approved_by)">More Approvals Needed.</p>
              <p v-if="scope.row.has_conflicts">
                There is Conflict in Merge Request.
              </p>
              <p v-else>
                There is No Conflict in Merge Request.
              </p>
            </template>
          </el-table-column>
        </el-table>
      </el-col>
    </el-row>
  </div>
</template>

<script>
import { mapState } from "vuex";

export default {
  name: "MergeRequestListTable",
  props: ["apiParams", "data"],
  components: {
    // GenericPopup,
  },

  computed: {
    ...mapState({
      userName: (state) => state.userName,
      email: (state) => state.email,
      admins: (state) => state.env.VUE_APP_DASHBOARD_ADMIN,
    }),
  },
  data() {
    return {
      tableData: [],
      mergedList: [],
      openedList: [],
      emptydata: [{}],
      switch: true,
      mergeListState: "opened",
      loading: true,
      merge_iid: false,
      showApprovers: {
        show: false,
        data: [],
      },
    };
  },
  methods: {
    async fetchApproovals() {
      let directusUrl = `/merge_requests/${this.$route.params.project_id}/directus/approvers`;
      const config = {
        method: "get",
        url: directusUrl,
      };
      let data = await this.$axios(config);
      let { approvers, no_of_approvers } = data.data.data[0];

      approvers = approvers.map(
        (person) => person.approvers_approvers_id.email
      );

      this.showApprovers = {
        show: true,
        data: [{ approvers, no_of_approvers }],
        requiredNo: no_of_approvers,
      };
    },
    mergeOpenRequest(iid) {
      
      let mergeUrl = `/merge-screen/${this.$route.params.project_id}/${iid}/merge`;
      this.$router.push(mergeUrl);
    },
    switchMergeList(stateValue) {
      if (stateValue === "opened") {
        this.tableData = this.openedList;
      } else if (stateValue === "merged") {
        this.tableData = this.mergedList;
      }
    },
    checkMerge(gitlabApprovers){
      return this.showApprovers.data[0].approvers.filter((item)=>gitlabApprovers.includes(item)).length >= this.showApprovers.requiredNo 
    }
  },
  mounted() {
    this.loading = true;
    let baseurl = this.$route.query.baseurl
    if(baseurl == undefined || baseurl == ' ' || baseurl == null){
      baseurl = 'https://gitlab.com'
    }
    const config = {
      method: "get",
      url: `/merge_requests/${this.$route.params.project_id}?baseurl=${baseurl}`,
    };

    this.fetchApproovals();

    this.$axios(config)
      .then((res) => {
        this.loading = false;
        this.tableData = res.data;
        // console.log(this.tableData)
        this.tableData.forEach(element => {
          if(element.state === 'opened'){
            this.openedList.push(element)
          }
          if(element.state === "merged"){
            this.mergedList.push(element)
          }
        });
        this.tableData = this.openedList;
      })
      .catch((err) => {
        console.log(err);
      });
  },
};
</script>
<style scoped>
.mrTable {
  display: flex;
  flex-direction: column;
}
.navigation {
  text-align: center;
  display: flex;
  justify-content: center;
  align-items: center;
}
.navigation {
  width: 30em;
  margin: auto;
  display: flex;
  justify-content: center;
  align-items: center;
}
.navigation label {
  width: 50%;
}

p {
  margin: 0px;
  padding: 0px;
}
h4 {
  text-align: center;
  color: blue;
}
</style>